using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace Csharp_popupexample
{
	/// <summary>
	/// Summary description for frmTVW.
	/// </summary>
	public class frmTVW : System.Windows.Forms.Form
	{
		public  AlterS.PopUp  ParentPopUp;
		public bool SupressDataExch;


		internal System.Windows.Forms.TreeView tvw;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public frmTVW()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			InitParams();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.tvw = new System.Windows.Forms.TreeView();
			this.SuspendLayout();
			// 
			// tvw
			// 
			this.tvw.BackColor = System.Drawing.Color.FloralWhite;
			this.tvw.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.tvw.Dock = System.Windows.Forms.DockStyle.Fill;
			this.tvw.ForeColor = System.Drawing.SystemColors.WindowText;
			this.tvw.ImageIndex = -1;
			this.tvw.Location = new System.Drawing.Point(1, 1);
			this.tvw.Name = "tvw";
			this.tvw.SelectedImageIndex = -1;
			this.tvw.Size = new System.Drawing.Size(216, 166);
			this.tvw.TabIndex = 1;
			// 
			// frmTVW
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.SystemColors.Desktop;
			this.ClientSize = new System.Drawing.Size(218, 168);
			this.ControlBox = false;
			this.Controls.Add(this.tvw);
			this.DockPadding.All = 1;
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Name = "frmTVW";
			this.ShowInTaskbar = false;
			this.Load += new System.EventHandler(this.frmTVW_Load);
			this.ResumeLayout(false);

		}
		#endregion


		private void InitParams(){
			System.Windows.Forms.TreeNode nodX1;
			System.Windows.Forms.TreeNode nodXr;

			tvw.Nodes.Clear();

			nodXr = tvw.Nodes.Add("Commands");
			nodXr.Tag = "R";

			tvw.SelectedNode = nodXr;
			tvw.SelectedNode.Nodes.Add("Command1");
			tvw.SelectedNode.Nodes.Add("Command2");
			tvw.SelectedNode.Nodes.Add("Command3");
			tvw.SelectedNode.Nodes.Add("Command4");
			tvw.SelectedNode.Nodes.Add("Command5");
			nodX1 = tvw.SelectedNode.Nodes.Add("Another commands...");
			nodX1.Tag = "R";

			tvw.SelectedNode = nodX1;
			tvw.SelectedNode.Nodes.Add("Command6");
			tvw.SelectedNode.Nodes.Add("Command7");
			tvw.SelectedNode.Nodes.Add("Command8");
			tvw.SelectedNode.Nodes.Add("Command9");
			tvw.SelectedNode.Nodes.Add("Command10");
			tvw.SelectedNode.Nodes.Add("Command11");

			nodXr.EnsureVisible();
			tvw.SelectedNode = nodXr;
			tvw.BorderStyle = BorderStyle.None;
		}

		private void frmTVW_Load(object sender, System.EventArgs e)
		{
			tvw.BeforeCollapse +=new TreeViewCancelEventHandler(tvw_BeforeCollapse);
			tvw.BeforeExpand +=new TreeViewCancelEventHandler(tvw_BeforeExpand);
			tvw.MouseMove +=new MouseEventHandler(tvw_MouseMove);
			tvw.MouseUp +=new MouseEventHandler(tvw_MouseUp);
		}

		private void tvw_BeforeCollapse(object sender, TreeViewCancelEventArgs e)
		{
			SupressDataExch = true;
		}

		private void tvw_BeforeExpand(object sender, TreeViewCancelEventArgs e)
		{
			SupressDataExch = true;
		}

		private void tvw_MouseMove(object sender, MouseEventArgs e)
		{
			Point pt = new Point(e.X,e.Y);
			TreeNode n;

	        n = tvw.GetNodeAt(pt);
			if (n !=null){
				tvw.SelectedNode = n;
			}
		}

		private void tvw_MouseUp(object sender, MouseEventArgs e)
		{
			Point pt = new Point (e.X,e.Y);
			TreeNode n;

			if (SupressDataExch){
				SupressDataExch = false;
				return;
			}

			n = tvw.GetNodeAt(pt);

			if (n==null) {return;};

			if (n.Tag != null) {return;};


			if (e.Button == MouseButtons.Left) {
				if (ParentPopUp != null){

					this.Enabled = false;
					//In the code above we disable the popup form before 
					//it is hidden. This should be done because the 
					//TreeView control tries to return focus after the 
					//form is hidden. If this happens, the main form 
					//becomes inactive (this gives unwanted visual effects).
					//The form is enabled in the popListBox_BeforePopUp
					//event handler. 
					//Another control that may try to return focus in such 
					//situation is ListView. 

					ParentPopUp.RaiseEventNotify();
					ParentPopUp.HidePopUpForm();
				}
			}
		}
	}
}
